/*
 *    Copyright (c) 2018-2025, lengleng All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the yifu4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: lengleng (wangiegie@gmail.com)
 */
package com.yifu.cloud.plus.v1.msg.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yifu.cloud.plus.v1.msg.entity.TMessageInfo;
import com.yifu.cloud.plus.v1.msg.mapper.TMessageInfoMapper;
import com.yifu.cloud.plus.v1.msg.service.TMessageInfoService;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Service;

/**
 * 消息提醒
 *
 * @author huyc
 * @date 2023-07-26 14:19:33
 */
@Log4j2
@Service
public class TMessageInfoServiceImpl extends ServiceImpl<TMessageInfoMapper, TMessageInfo> implements TMessageInfoService {
    /**
     * 消息提醒简单分页查询
     * @param tMessageInfo 消息提醒
     * @return
     */
    @Override
    public IPage<TMessageInfo> getTMessageInfoPage(Page<TMessageInfo> page, TMessageInfo tMessageInfo){
        return baseMapper.getTMessageInfoPage(page,tMessageInfo);
    }

	@Override
	public boolean saveMessage(TMessageInfo tMessageInfo) {

		return false;
	}

	@Override
	public void updateMessageInfo(TMessageInfo tMessageInfo) {
		if (Common.isNotNull(tMessageInfo) && Common.isNotNull(tMessageInfo.getAlertUser())) {
			TMessageInfo tMessageInfo1 = null;
			if (Common.isNotNull(tMessageInfo.getModelId())) {
				tMessageInfo1 = baseMapper.selectOne(Wrappers.<TMessageInfo>query().lambda()
						.eq(TMessageInfo::getAlertUser, tMessageInfo.getAlertUser())
						.eq(TMessageInfo::getModelId, tMessageInfo.getModelId())
						.orderByDesc(TMessageInfo::getCreateTime).last(CommonConstants.LAST_ONE_SQL));
			} else if (Common.isNotNull(tMessageInfo.getInfoUrl())){
				tMessageInfo1 = baseMapper.selectOne(Wrappers.<TMessageInfo>query().lambda()
						.eq(TMessageInfo::getAlertUser, tMessageInfo.getAlertUser())
						.eq(TMessageInfo::getInfoUrl, tMessageInfo.getInfoUrl())
						.orderByDesc(TMessageInfo::getCreateTime).last(CommonConstants.LAST_ONE_SQL));
			}
			if (Common.isNotNull(tMessageInfo1)) {
				tMessageInfo1.setHandlerStatus(tMessageInfo.getHandlerStatus());
			}
		}
	}

	@Override
	public long selectMessageCount(TMessageInfo tMessageInfo) {
		return baseMapper.selectCount(Wrappers.<TMessageInfo>query().lambda()
				.eq(TMessageInfo::getAlertUser,tMessageInfo.getAlertUser())
				.eq(TMessageInfo::getModelId,tMessageInfo.getModelId())
				.eq(TMessageInfo::getHandlerStatus,CommonConstants.ONE_STRING));
	}
}
